#!/usr/bin/perl -w

use strict;
use Cwd;

my $main_dir	= getcwd;
my $main_page	= 'output/index.html';
my $indir	= 'main-articles';				# the input directory name
my $outdir	= 'output';					# the output directory name
my $pagedir	= 'pages';					# individual pages directory
my @maint	= qx(cat template/main-top);			# top section for main page
my @mainb	= qx(cat template/main-bottom);			# bottom section for main page
my @footer	= qx(cat template/footer);			# footer for every page incl main
my @paget	= qx(cat template/page-top);			# top section for every page in pages/
my @pageb	= qx(cat template/page-bottom);			# bottom section for every page in pages/
my @articlet	= qx(cat template/article-top);			# top section for every article in main-articles/
my @articleb	= qx(cat template/article-bottom);		# bottom section for every article in main-articles/

unlink glob "output/*.html"; 					# remove old pages
unlink "output/tmp";						# file which stores menu
open (OUT, '>', "$outdir/index.html") or die $!;		# create the index.html page
print OUT @maint;

chdir($pagedir) or die "Can't change path to $pagedir $!\n";
print "\n\t\t\tblipper (BLog In PERl) v0.1\n\n";
print "Entering " . getcwd . "\n\n";
open (OUT, '>>', "../$outdir/tmp") or die $!;			# begin creating menu for individual pages in a file
print OUT "<ul>"; 						# begin list for menu items
print OUT "<li><a href=\"index.html\">home</a></li>";

my @pages = <*>;						# create individual pages
foreach my $page (@pages) {
	print "Generating page: ";
	printf("%-30s", $page);
	print "\t==> output page:\t" . "../$outdir/$page.html\n";
	my @array = qx(cat $page);
	open (OUT, '>', "../$outdir/$page.html") or die $!;
	print OUT @paget;
	my @html = qx(Markdown.pl $page);
	print OUT @html;
	print OUT @pageb;
	close OUT;

	open (OUT, '>>', "../$outdir/tmp") or die $!;		# append page links to tmp file
	print OUT "<li><a href=\"$page.html\">$page</a></li>";
}

print OUT "</ul>";
print OUT "<hr>";
print OUT "<br>";
close OUT or die $!;

chdir($main_dir) or die "Can't change path to $main_dir $!\n";
print "\nIndividual page generation completed. ";
chdir($indir) or die "Can't change path to $indir $!\n";
print "Entering " . getcwd . "\n\n";

my @files = <*>;
foreach my $file (@files) {					# Read each file(post) from indir, cat to $outdir/$file.html
	print "Processing file: ";
	printf ("%-30s", $file);
	print "\t==> output file:\t" . "../$outdir/$file.html\n";
	my @array = qx(cat $file);
	open (OUT, '>', "../$outdir/$file.html") or die $!;
	print OUT @articlet;
	my @html = qx(Markdown.pl $file);			# markdown to html
	print OUT @html;					# append content
	print OUT @articleb;
	close OUT;

	open (OUT, '>>', "../$outdir/index.html") or die $!;	# append links to stories in index.html
	print OUT "<a href=\"$file.html\">$file</a>";
	print OUT "\n";
	print OUT "<br>";
}

open (OUT, '>>', "../$outdir/index.html") or die $!;		# close all tags in index.html
print OUT @mainb;
print OUT @footer;
close OUT;

print "\nLeaving " . getcwd . "\n";
chdir($main_dir) or die "Can't change path to $main_dir $!\n";
print "Site generation completed. Files are in output/ dir.\n";
